﻿Imports System.Math

Public Class Form1

    Dim randNum1 As Integer
    Dim randNum2 As Integer
    Dim numPics As Integer = 6
    Dim count1 As Integer
    Dim pic1 As String
    Dim speed As Single = 20
    Dim rndInst As New Random()
    Dim xVel As Single = Math.Cos(rndInst.Next(5, 10)) * speed
    Dim yVel As Single = Math.Sin(rndInst.Next(5, 10)) * speed

    Private Sub tmrDie_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrDie.Tick
        'Start the random number generator
        Randomize()

        'Assign a random number to a variable
        randNum1 = CInt(Int((numPics * Rnd()) + 1))

        'Show the picture for the random number
        Select Case randNum1
            Case 1
                pbxSixSided.Image = iLstSixDie.Images.Item(0)
            Case 2
                pbxSixSided.Image = iLstSixDie.Images.Item(1)
            Case 3
                pbxSixSided.Image = iLstSixDie.Images.Item(2)
            Case 4
                pbxSixSided.Image = iLstSixDie.Images.Item(3)
            Case 5
                pbxSixSided.Image = iLstSixDie.Images.Item(4)
            Case 6
                pbxSixSided.Image = iLstSixDie.Images.Item(5)
        End Select

        'Count 1 for every round
        count1 += 1

        'If the count equals the number of rotations,
        '   then stop the wheel, and reset the count
        If count1 = Val(txtRotations.Text) Then
            tmrDie.Enabled = False
            count1 = 0
        End If

        'Move the picture box.
        MovePic()

        'Rotate the picture in the picture box.
        Rotate()

    End Sub

    Private Sub btnRoll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRoll.Click
        tmrDie.Enabled = True
        tmrDie.Interval = Val(txtInterval.Text)
    End Sub

    Public Sub MovePic()
        ' Move the picturebox.
        pbxSixSided.Location = New Point(pbxSixSided.Location.X - xVel, pbxSixSided.Location.Y + yVel)

        ' Check for top.
        If pbxSixSided.Location.Y < 0 Then
            pbxSixSided.Location = New Point(pbxSixSided.Location.X, 0)
            yVel = -yVel
        End If

        ' Check for bottom.
        If pbxSixSided.Location.Y > Panel1.Bottom - (pbxSixSided.Height + 32) Then
            pbxSixSided.Location = New Point(pbxSixSided.Location.X, Panel1.Height - pbxSixSided.Size.Height)
            yVel = -yVel
        End If

        'Check for left.
        If pbxSixSided.Location.X < 0 Then
            pbxSixSided.Location = New Point(0, pbxSixSided.Location.Y)
            xVel = -xVel
        End If

        'Check for right.
        If pbxSixSided.Location.X + pbxSixSided.Width > Panel1.Width Then
            pbxSixSided.Location = New Point(Panel1.Width - pbxSixSided.Width, _
            pbxSixSided.Location.Y)
            xVel = -xVel
        End If
    End Sub

    Public Sub Rotate()
        'Copy the output bitmap from the source image.
        Dim startPic As New Bitmap(pbxSixSided.Image)

        'Make an array of points defining the image's corners.
        Dim wid As Single = startPic.Width
        Dim hgt As Single = startPic.Height
        Dim corners As Point() = { _
            New Point(0, 0), _
            New Point(wid, 0), _
            New Point(0, hgt), _
            New Point(wid, hgt)}

        'Translate to center the bounding box at the origin.
        Dim cx As Single = wid / 2
        Dim cy As Single = hgt / 2
        Dim i As Long
        For i = 0 To 3
            corners(i).X -= cx
            corners(i).Y -= cy
        Next i

        'Rotate.
        randNum2 = CInt(Int((360 * Rnd()) + 1))
        Dim theta As Single = Single.Parse(randNum2) * PI / 180.0

        Dim sin_theta As Single = Sin(theta)
        Dim cos_theta As Single = Cos(theta)
        Dim X As Single
        Dim Y As Single
        For i = 0 To 3
            X = corners(i).X
            Y = corners(i).Y
            corners(i).X = X * cos_theta + Y * sin_theta
            corners(i).Y = -X * sin_theta + Y * cos_theta
        Next i

        'Translate so X >= 0 and Y >=0 for all corners.
        Dim xmin As Single = corners(0).X
        Dim ymin As Single = corners(0).Y
        For i = 1 To 3
            If xmin > corners(i).X Then xmin = corners(i).X
            If ymin > corners(i).Y Then ymin = corners(i).Y
        Next i
        For i = 0 To 3
            corners(i).X -= xmin
            corners(i).Y -= ymin
        Next i

        'Create an output Bitmap and Graphics object.
        Dim finishPic As New Bitmap(CInt(-2 * xmin), CInt(-2 * ymin))
        Dim picOut As Graphics = Graphics.FromImage(finishPic)

        'Drop the last corner lest we confuse DrawImage, 
        'which expects an array of three corners.
        ReDim Preserve corners(2)

        'Draw the result onto the output image.
        picOut.DrawImage(startPic, corners)

        'Display the result.
        pbxSixSided.Image = finishPic
    End Sub

End Class
